-- Most of the comments to the code (and the "well written" part of it :-) are by Phanx, whom I thanks for the helps and patience in explaining. 
-- The layout of the input frame was inspired by the one of : http://www.wowinterface.com/downloads/info21884-AutoRun_Reminder.html

RemGankDB = {};
local cmd, name, note
local default_note="generic ganker"
local prgname = "|cffffd200remgank|r"

local bgfile = "Interface\\DialogFrame\\UI-DialogBox-Background"
local edgefile = "Interface\\DialogFrame\\UI-DialogBox-Border"

-- For general use, I wouldn't recommend obsessively upvaluing every
-- global but it is worth doing for situations like CLEU or OnUpdate
-- where you are accessing them extremely often.
local string_format = string.format
local bit_band = bit.band
local COMBATLOG_OBJECT_CONTROL_PLAYER = COMBATLOG_OBJECT_CONTROL_PLAYER

-- GUIDs are not available when the main chunk executes, so you have to
-- wait and fill this in once the combat log starts running.
local playerGUID

local function RemGank_Add_Player(sourceName) 
		RemGank_Input_Player:SetText(sourceName)
		RemGank_Input:Show()
end
	

local function RemGank_Record_Player(name, note) 	
	if not  note then  note = default_note end
	RemGankDB[name:lower()] = string.sub(note,1,25)
	print(string_format("%s: adding %s [ %s ] to list", prgname, name, note))	
end

local RemGank_Input = CreateFrame("Frame","RemGank_Input",UIParent)
	RemGank_Input:SetBackdrop({ bgFile =  bgfile, edgeFile = edgefile, tile=1, tileSize=32, edgeSize=32, insets={left=11, right=12, top=12, bottom=11}})
	RemGank_Input:SetWidth(250)
	RemGank_Input:SetHeight(180)
	RemGank_Input:SetPoint("CENTER",UIParent)
	RemGank_Input:EnableMouse(true)
	RemGank_Input:SetMovable(true)
	RemGank_Input:RegisterForDrag("LeftButton")
	RemGank_Input:SetScript("OnDragStart", function(self) self:StartMoving() end)
	RemGank_Input:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	RemGank_Input:SetFrameStrata("FULLSCREEN_DIALOG")
	RemGank_Input:SetUserPlaced(true)
	RemGank_Input:Hide()
	RemGank_Input:SetClampedToScreen(true)

-- Title
local RemGank_Input_Title = RemGank_Input:CreateFontString("RemGank_Input_Title")
	RemGank_Input_Title:SetPoint("TOPLEFT", RemGank_Input,"TOPLEFT",86, -14)
	RemGank_Input_Title:SetFont('Fonts\\FRIZQT__.ttf',14)
	RemGank_Input_Title:SetTextColor(1,0,0,1)
	RemGank_Input_Title:SetText('- RemGank -')

-- Text
local RemGank_Input_Text1 = RemGank_Input:CreateFontString("RemGank_Input_Text1")
	RemGank_Input_Text1:SetPoint("TOPLEFT", RemGank_Input,"TOPLEFT",20, -40)
	RemGank_Input_Text1:SetFont('Fonts\\FRIZQT__.ttf',12)
	RemGank_Input_Text1:SetTextColor(0.6,0.6,0.6,1)
	RemGank_Input_Text1:SetText('Add to your list:')

-- Player Name	
local RemGank_Input_Player = RemGank_Input:CreateFontString("RemGank_Input_Player")
	RemGank_Input_Player:SetPoint("TOPLEFT", RemGank_Input,"TOPLEFT",20, -65)
	RemGank_Input_Player:SetFont('Fonts\\FRIZQT__.ttf',14)
	RemGank_Input_Player:SetTextColor(1,0,0,1)
	
-- Text
local RemGank_Input_Text2 = RemGank_Input:CreateFontString("RemGank_Input_Text2")
	RemGank_Input_Text2:SetPoint("TOPLEFT", RemGank_Input,"TOPLEFT",20, -95)
	RemGank_Input_Text2:SetFont('Fonts\\FRIZQT__.ttf',12)
	RemGank_Input_Text2:SetTextColor(0.6,0.6,0.6,1)
	RemGank_Input_Text2:SetText('Note (optional)')
	
-- EditBox1
local RemGank_Input_eb1 = CreateFrame("EditBox", "eb1",RemGank_Input)
	RemGank_Input_eb1:SetPoint("TOPLEFT", RemGank_Input,"TOPLEFT",20, -110)
	RemGank_Input_eb1:SetWidth(200)
	RemGank_Input_eb1:SetHeight(13)
	RemGank_Input_eb1:SetMaxLetters(25)
	RemGank_Input_eb1:SetFont('Fonts\\FRIZQT__.ttf',12)
	RemGank_Input_eb1:SetText('generic ganker')

-- Save button
local RemGank_Input_Save_Button = CreateFrame("button","RemGank_Input_Save_Button", RemGank_Input, "UIPanelButtonTemplate")
RemGank_Input_Save_Button:SetHeight(25)
RemGank_Input_Save_Button:SetWidth(50)
RemGank_Input_Save_Button:SetPoint("BOTTOMRIGHT", RemGank_Input, "BOTTOMRIGHT", -12, 12)
RemGank_Input_Save_Button:SetText("Yes")
RemGank_Input_Save_Button:SetScript("OnClick", 
		function()
			RemGank_Input:Hide()
			RemGank_Record_Player(RemGank_Input_Player:GetText(), RemGank_Input_eb1:GetText())
                        end) 
	
-- Canc Button
local RemGank_Input_Canc_Button = CreateFrame("button","RemGank_Input_Canc_Button", RemGank_Input, "UIPanelButtonTemplate")
RemGank_Input_Canc_Button:SetHeight(25)
RemGank_Input_Canc_Button:SetWidth(50)
RemGank_Input_Canc_Button:SetPoint("BOTTOMLEFT", RemGank_Input, "BOTTOMLEFT", 12, 12)
RemGank_Input_Canc_Button:SetText("No")
RemGank_Input_Canc_Button:SetScript("OnClick",  function() RemGank_Input:Hide() end) 
	
	
local frame_cleu = CreateFrame("FRAME", "remgankframe_cleu")
-- Don't register COMBAT_LOG_EVENT_UNFILTERED here!
frame_cleu:RegisterEvent("ZONE_CHANGED_NEW_AREA")
frame_cleu:RegisterEvent("PLAYER_ENTERING_WORLD")

frame_cleu:SetScript("OnEvent", function(self, event, ...)
   
	if event == "ZONE_CHANGED_NEW_AREA" or event == "PLAYER_ENTERING_WORLD" then	
		local _, instanceType = IsInInstance()
		if instanceType == "arena" or instanceType == "pvp" or (instanceType == "none" and GetZonePVPInfo() == "combat") then
			-- arena is, obviously, an arena.
			-- pvp is a battleground.
			-- none with GetZonePVPInfo() == "combat" is an outdoor PvP zone like Wintergrasp.
			self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		else
			-- If not in a pvp zone, register CLEU:
			self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		end
		return
	end

	local timeStamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, prefixParam1, prefixParam2, dummyparam, suffixParam1, suffixParam2 = ...
	
    -- proceed with CLEU handling
	if not playerGUID then
		playerGUID = UnitGUID("player")
	end

	-- Since these first two conditions apply no matter which event is
	-- firing, check them first.
	if destGUID == playerGUID and bit_band(sourceGUID, COMBATLOG_OBJECT_CONTROL_PLAYER) == COMBATLOG_OBJECT_CONTROL_PLAYER then
		if event == "SWING_DAMAGE" then
			-- Nest checks inside each other instead of using and, so
			-- that if any check matches (eg. it is this event, but not
			-- the right prefix) the code doesn't keep checking other
			-- things that obviously can never match.
			if prefixParam2 > 0 then
				print(string_format("%s: [%s] killed [%s] with %s Melee overkill %s", prgname, sourceName, destName, prefixParam1, suffixParam2))
				RemGank_Add_Player(sourceName) 
			end
		elseif event == "SPELL_DAMAGE" or event == "SPELL_PERIODIC_DAMAGE" or event == "RANGE_DAMAGE" then
			if suffixParam2 > 0 then
				print(string_format("%s: [%s] killed [%s] with %s damage of %s overkill %s", prgname, sourceName, destName, suffixParam1, GetSpellLink(prefixParam1), suffixParam2))
				RemGank_Add_Player(sourceName) 
			end
		end
	end

end)
	
local frame_umu = CreateFrame("FRAME", "remgankframe_umu")
frame_umu:RegisterEvent("UPDATE_MOUSEOVER_UNIT");
frame_umu:SetScript("OnEvent", function (self, event, ...)
	if ((UnitIsPlayer("mouseover")) and (UnitIsEnemy("mouseover", "player"))) then
			local player = UnitName("mouseover");
			if RemGankDB[player:lower()] then
				GameTooltip:AddLine("RemGank: " .. RemGankDB[player:lower()] )
				GameTooltipTextLeft1:SetTextColor(1, 0.5, 0.5)
				GameTooltip:SetBackdropColor(1, 0, 0)
				GameTooltip:Show()
			end
	end
 end);

 
SLASH_REMGANK1 = "/remgank";
SlashCmdList["REMGANK"] = function(args) 
	local cmd, name, note = string.split(" ", args, 3)
	
	if cmd == "add" then
		if name then  RemGank_Record_Player(name, note) end
		
	elseif cmd == "del" then
		if not name then return end
		print(string_format("%s: removing %s from list", prgname, name))
		RemGankDB[name] = nil
		
	elseif cmd == "list" then
		print(prgname .. " printing list")
		for name,note in pairs(RemGankDB) do 
			print(string_format("%s, %s",name,note))
		end
		
	elseif cmd == "wipe" then
		print(prgname .. " deleting list")
		for name in pairs(RemGankDB) do
			RemGankDB[name] = nil
		end
	
	elseif cmd == "debugaddframe" then
		RemGank_Add_Player("TestName") 
	
	else
		print(prgname .. " commands")
		print("/remgank - This help")
		print("/remgank add <player_name> <note> - Add a ganker")
		print("/remgank del <player_name> - Remove a ganker")
		print("/remgank list - List those silly gankers")				
		print("/remgank wipe - Erase all the table")
		return
	end
	
end
